#! /bin/bash
# -----------------------------------------------------------------------------------------------------------
# Tuxbox Build & Compiler Helper
# by yjogol (yjogol@online.de)
# $Date: 2007/01/20 11:58:08 $
# $Revision: 1.1 $
# -----------------------------------------------------------------------------------------------------------

# -----------------------------------------------------------------------------------------------------------
# Menu
# -----------------------------------------------------------------------------------------------------------
buildconf_menu()
{
	if [ "$SDEBUG" == "0" ]; then
		clear
	fi
	echo "==============================================================================="
	echo "Menu: Build Selection"
	echo "Version: $yb_version Date: $yb_date"
	echo "-------------------------------------------------------------------------------"
	echo "0 - Build Target..............: $cBuildTARGET"
	echo "1 - GUI.......................: $cBuildGUI"
	echo "2 - Filesystem................: $cBuildFS"
	echo "3 - Chips.....................: $cBuildCHIPS"
	echo ""
	echo "b - Back"
	echo "==============================================================================="
	echo "Enter command:"
}

# -----------------------------------------------------------------------------------------------------------
# $1=Variable Value, $2=Description
# Return in $buildconf_editvalue
# -----------------------------------------------------------------------------------------------------------
buildconf_editvariable()
{
	buildconf_editvalue=$1
	echo "Description: $2"
	echo "Actual.....: $1"
	echo "Enter Value:"
	read val $1
	if [ "$val" != "" ]
	then
		buildconf_editvalue=$val
	fi
}

# -----------------------------------------------------------------------------------------------------------
# Menu Loop
# -----------------------------------------------------------------------------------------------------------
buildconf()
{
	buildconf_editvalue=""
	buildconf_doquit=false
	while [ "$buildconf_doquit" == "false" ]
	do
		buildconf_menu
		read cmd
		
		case "$cmd" in 
			0)	buildconf_editvariable $cBuildTARGET "Build Target: 1-Flash, 2-Yadd"
				case "$buildconf_editvalue" in
					1) cBuildTARGET="flash" ;;
					2) cBuildTARGET="yadd" ;;
				esac
				config_set_value_direct $yb_configfile cBuildTARGET "$cBuildTARGET"
				;;

			1)	buildconf_editvariable $cBuildGUI "GUI: 1-Neutrino, 2-Enigma, 3-LCARS, 4-Radiobox, 5-null"
				case "$buildconf_editvalue" in
					1) cBuildGUI="neutrino" ;;
					2) cBuildGUI="enigma" ;;
					3) cBuildGUI="lcars" ;;
					4) cBuildGUI="radiobox" ;;
					4) cBuildGUI="null" ;;
				esac
				config_set_value_direct $yb_configfile cBuildGUI "$cBuildGUI"
				;;

			2)	buildconf_editvariable $cBuildFS "Filesystem: 1-JFFS2, 2-Squashfs, 3-Cramfs"
				case "$buildconf_editvalue" in
					1) cBuildFS="jffs2" ;;
					2) cBuildFS="squashfs" ;;
					3) cBuildFS="cramfs" ;;
				esac
				config_set_value_direct $yb_configfile cBuildFS "$cBuildFS"
				;;

			3)   buildconf_editvariable $cBuildCHIPS "chips: 1-1x, 2-2x, 3-all"
				case "$buildconf_editvalue" in
					1) cBuildCHIPS="1x" ;;
					2) cBuildCHIPS="2x" ;;
					3) cBuildCHIPS="all" ;;
				esac
				config_set_value_direct $yb_configfile cBuildCHIPS "$cBuildCHIPS"
				;;

			b)	buildconf_doquit="true"
				;;
		esac
	done 
}