# -----------------------------------------------------------------------------------------------------------
# Tuxbox Build & Compiler Helper
# by yjogol (yjogol@online.de)
# $Date: 2007/01/20 11:58:08 $
# $Revision: 1.3 $
# -----------------------------------------------------------------------------------------------------------

# -----------------------------------------------------------------------------------------------------------
# Initialize used configuration variables
# -----------------------------------------------------------------------------------------------------------
init_variables()
{
	#------------------------------------------
	# Default Directory Structure 
	#------------------------------------------
	SCRIPTDIR=$cWORKINGDIR/$cSCRIPTDIR
	MYFILESDIR=$cWORKINGDIR/$cMYFILESDIR
	LOGOSDIR=$cWORKINGDIR/$cMYFILESDIR/$cLOGOSDIR
	UCODESDIR=$cWORKINGDIR/$cMYFILESDIR/$cUCODESDIR
	MyLOCALSDIR=$cWORKINGDIR/$cMYFILESDIR/$cMyLOCALSDIR
	MyPATCHESDIR=$cWORKINGDIR/$cMYFILESDIR/$cMyPATCHESDIR
	MyDBOXFILESDIR=$cWORKINGDIR/$cMYFILESDIR/$cMyDBOXFILESDIR
	CVSDIR=$cWORKINGDIR/$cCVSDIR
	DBOX_PREFIX=$cWORKINGDIR/$cDBOX_PREFIX
	ARCHIVEDIR=$cWORKINGDIR/$cARCHIVEDIR
	
	#------------------------------------------
	# other Settings
	#------------------------------------------
	export CVS_RSH=ssh
}
# -----------------------------------------------------------------------------------------------------------
# Show variables (for debug issues)
# -----------------------------------------------------------------------------------------------------------
show_variables()
{
	echo " - Working Directory.......: $cWORKINGDIR"
	echo " -- Script Directory.......: $cSCRIPTDIR  (cWORKINGDIR/$cSCRIPTDIR)"
	echo " -- Custom Directory.......: $cMYFILESDIR  ($cWORKINGDIR/$cMYFILESDIR)"
	echo " ---   Logos  Directory....: $cLOGOSDIR  ($cWORKINGDIR/$cMYFILESDIR/$cLOGOSDIR)"
	echo " ---   Ucodes Directory....: $cUCODESDIR  ($cWORKINGDIR/$cMYFILESDIR/$cUCODESDIR)"
	echo " ---   locals Directory....: $cMyLOCALSDIR  ($cWORKINGDIR/$cMYFILESDIR/$cMyLOCALSDIR)"
	echo " ---   Patches Directory...: $cMyPATCHESDIR  ($cWORKINGDIR/$cMYFILESDIR/$cMyPATCHESDIR)"
	echo " ---   dbox-Files Directory: $cMyDBOXFILESDIR  ($cWORKINGDIR/$cMYFILESDIR/$cMyDBOXFILESDIR)"
	echo " -- DBOX Directory.........: $cDBOX_PREFIX  ($cWORKINGDIR/$cDBOX_PREFIX)"
	echo " -- ARCHIVE Directory......: $cARCHIVEDIR  ($cWORKINGDIR/$cARCHIVEDIR)"
	echo " -- CVS Directory..........: $cCVSDIR  ($cWORKINGDIR/$cCVSDIR)"
	echo ""
	echo " CVS Username..............: $CVSNAME (for anonymous: anoncvs)"
}

# ===========================================================
# config-Dateien - lesen / schreiben
# (Zeilenformat: VarName=VarValue)
# ===========================================================
# -----------------------------------------------------------------------------------------------------------
# variable given by varname ($1) prompt for value, update var and write to conffile 
# $1=Variable name, $2=Default value, $3=Description
# Return in $basisconf_editvalue
# -----------------------------------------------------------------------------------------------------------
config_editvariable()
{
	varname=$1
	val=${!varname}
	echo "Variable...: $1"
	echo "Description: $3"
	echo "Default....: $2"
	echo "Actual.....: $val"
	echo "Enter Value:"
	read val
	if [ "$val" != "" ]; then
		config_set_value_direct $yb_configfile $1 "$val"
		eval $varname=$val
	fi
}
# -----------------------------------------------------------------------------------------------------------
# Variable (name = $1) to by toggled ("y" to "n" or otherwise) and write it to configfile
# -----------------------------------------------------------------------------------------------------------
config_togglevariable()
{
	varname=$1
	val=${!varname}
	if  [ "$val" == "y" ]; then val="n"; else val="y"
	fi
	config_set_value_direct $yb_configfile $varname "$val"
	eval $varname=$val
}
# -----------------------------------------------------------
cfg=""
# -----------------------------------------------------------
# config-Datei lesen/cachen (Inhalt in $cfg)
# $1=config-Filename
# -----------------------------------------------------------
config_open()
{
	cfg=""
	cfg=`cat $1`
}
# -----------------------------------------------------------
# config-Datei schreiben (Inhalt in $cfg)
# $1=config-Filename
# -----------------------------------------------------------
config_write()
{
	echo "$cfg" >$1
}
# -----------------------------------------------------------
# Variablenwert zurueckgeben (vorher open)
# $1=VarName
# -----------------------------------------------------------
config_get_value()
{
	cmd="sed -n /^$1=/p"
	tmp=`echo "$cfg" | $cmd`
	cmd="sed -e s/^$1=//1"
	tmp=`echo "$tmp" | $cmd`
	echo $tmp
}
# -----------------------------------------------------------
# Variablenwert zurueckgeben (ohne open)
# $1=config-Filename
# $2=VarName
# -----------------------------------------------------------
config_get_value_direct()
{
	config_open $1
	config_get_value $2
}
# -----------------------------------------------------------
# Variablenwert setzen (vorher open)
# $1=VarName)
# $2=VarValue
# -----------------------------------------------------------
config_set_value()
{
	tmp=`echo "$cfg" | sed -n "/^$1=.*/p"`
	if [ "$tmp" = "" ]
	then
		cfg=`echo -e "$cfg\n$1=$2"`
	else
		cmd="sed -e s:^$1=.*:$1=$2:g"
		cfg=`echo "$cfg" | $cmd`
	fi
}
# -----------------------------------------------------------
# Variablenwert zurueckgeben (ohne open)
# $1=config-Filename
# $2=VarName)
# $3=VarValue
# -----------------------------------------------------------
config_set_value_direct()
{
	config_open $1
	config_set_value $2 $3
	config_write $1
}
 
